;-------------------------------------------------
; HSV_color
; Intro. IDL program. (2013): Chapt. 6.6  
; Author:  Tadashi Ito     
;-------------------------------------------------
;--------------
;  draw_1 event
;
pro d1_ev,ev
widget_control, ev.top, get_uvalue=uv0,/no_copy
;--- case mouse click
if( ev.type eq 0) then begin
    if( ev.press eq 1) then begin
        ri=(*uv0.pr)[ev.x,ev.y] & gi=(*uv0.pg)[ev.x,ev.y] & bi=(*uv0.pb)[ev.x,ev.y]
        widget_control,uv0.t1_id,set_value=string(ri,format='(i6)' )
        widget_control,uv0.t2_id,set_value=string(gi,format='(i6)' )
        widget_control,uv0.t3_id,set_value=string(bi,format='(i6)' )
        rr=make_array(uv0.wh,uv0.wh,/byte,value=ri)
        gg=make_array(uv0.wh,uv0.wh,/byte,value=gi)
        bb=make_array(uv0.wh,uv0.wh,/byte,value=bi)
        wset, uv0.w2_id 
        tv,[[[rr]],[[gg]],[[bb]]],true = 3        
        wset, uv0.w3_id 
        y=sin(indgen(uv0.wh)*0.1)
        plot,y,color=color_no(ri,gi,bi),background=color_no(255,255,255)
        endif       
    endif
;--- cursor move  
    if(ev.type eq 2) then begin
        widget_control,uv0.l1_id,set_value='R:'+string((*uv0.pr)[ev.x,ev.y],format='(i6)')
        widget_control,uv0.l2_id,set_value='G:'+string((*uv0.pg)[ev.x,ev.y],format='(i6)')
        widget_control,uv0.l3_id,set_value='B:'+string((*uv0.pb)[ev.x,ev.y],format='(i6)')
        endif
widget_control, ev.top, set_uvalue=uv0,/no_copy
end
;--------------
;  quit button
;
pro bq_ev,ev
widget_control, /destroy, ev.top
end
;--------------
;  other events
;
pro HSV_color_event,ev
end
;-------------------------------------------
;  main routine
;
pro HSV_color
g0_id=widget_base(title="HSV_color",/column)
g1_id=widget_base(g0_id,/frame,/row)
g2_id=widget_base(g0_id,/row)
g3_id=widget_base(g2_id,/frame,/column)
g4_id=widget_base(g2_id,/frame,/column)
;--- labels  
l1_id=widget_label(g1_id,value='R:',uname='l1',xsize=60,/align_left)
l2_id=widget_label(g1_id,value='G:',uname='l2',xsize=60,/align_left)
l3_id=widget_label(g1_id,value='B:',uname='l3',xsize=60,/align_left)
;---text and button
t1_id=widget_text(g1_id,uname='t1',xsize=8,ysize=1)
t2_id=widget_text(g1_id,uname='t2',xsize=8,ysize=1)
t3_id=widget_text(g1_id,uname='t3',xsize=8,ysize=1)
bq_id=widget_button(g1_id,value="Quit",uname='bq',event_pro='bq_ev')
;---pallet size and v-value
w=400 & wh=w*0.5 & v0=1.0
;---draw
d1_id=widget_draw(g3_id,uname='d1',xsize=w,ysize=w, $
      /button_events,/motion_events,event_pro='d1_ev')
d2_id=widget_draw(g4_id,uname='d2',xsize=wh,ysize=wh) 
d3_id=widget_draw(g4_id,uname='d3',xsize=wh,ysize=wh) 
;----realize
widget_control, g0_id, /realize
widget_control, d1_id, get_value=w1_id
widget_control, d2_id, get_value=w2_id
widget_control, d3_id, get_value=w3_id
;---prepare color pallet                                                       
bin=(findgen(w)-wh+0.5)/wh
x=rebin(bin,w,w,/sample) 
y=transpose(x) 
h=!radeg*atan(x,y) 
s=sqrt(x^2+y^2) 
v=replicate(v0,w,w)
i = where(s gt 1.0, count)
if (count gt 0) then begin
   s[i] = 0.0  
   v[i] = 1.0  
   endif
color_convert, h,s,v, r,g,b, /hsv_rgb 
wset, w1_id
tv,[[[r]],[[g]],[[b]]],true = 3  
pr=ptr_new(r) & pg=ptr_new(g) & pb=ptr_new(b)
;--- set uv0
uv0={w:w, wh:wh, w1_id:w1_id, w2_id:w2_id, w3_id:w3_id, $
l1_id:l1_id, l2_id:l2_id,l3_id:l3_id, $
t1_id:t1_id,t2_id:t2_id,t3_id:t3_id, pr:pr, pg:pg, pb:pb}
widget_control, g0_id, set_uvalue=uv0,/no_copy
;---true color
device, decomposed = 1
;---call xmanager
xmanager, 'HSV_color', g0_id, cleanup='myclean', /no_block
end
