;-------------------------------------------------
; rotearth  ; rotating the earth 
; Intro. IDL program. (2013): Chapt. 7.3   
; Author:  Tadashi Ito     
;-------------------------------------------------
pro b1_ev,ev
  widget_control,ev.top,get_uvalue=uv0,/no_copy
  uv0.tsw=1
  widget_control,uv0.tm_id,timer=uv0.tsec
  widget_control, ev.top,set_uvalue=uv0,/no_copy  
end
;------------------
pro b2_ev,ev
  widget_control,ev.top,get_uvalue=uv0,/no_copy
  uv0.tsw=0
  widget_control, ev.top,set_uvalue=uv0,/no_copy  
end
;-----------------
pro bq_ev,ev 
  widget_control,/destroy,ev.top
end
;------------------------------
pro rotearth_event,ev
  widget_control, ev.top,get_uvalue=uv0,/no_copy  
  uv0.omodel->rotate,[0,1,0], uv0.ang0      
  uv0.owin->draw, uv0.oview 
  if uv0.tsw eq 1 then widget_control,uv0.tm_id,timer=uv0.tsec  
  widget_control, ev.top,set_uvalue=uv0,/no_copy
end
;-----------------
pro rotearth
;---widgets
g0_id=widget_base(title='Rotating Earth',/row)
g1_id=widget_base(g0_id,/frame,/column)
g2_id=widget_base(g0_id,/frame,/column,xsize=80)
tm_id=widget_base(g0_id, column=1,uvalue='timer')   
device,get_screen_size=ssize
ws=ssize[1]*0.7
d1_id=widget_draw(g1_id,uname='d1',xsize=ws,ysize=ws,graphics_level=2)  
b1_id=widget_button(g2_id,value='start',uname='b1',event_pro='b1_ev')
b2_id=widget_button(g2_id,value='stop',uname='b2',event_pro='b2_ev')
bq_id=widget_button(g2_id,value='end',uname='bq',event_pro='bq_ev')  
widget_control,g0_id,/realize        
;------ create object
oatom =mkoearth()
omodel=mkomodel()
omodel->add, oatom
oview =mkoview()
oview->add, omodel
;---rotate model to standard view.
omodel->rotate,[1,0,0], -90
;---draw
widget_control,d1_id,get_value=owin
owin->draw, oview
;---condition   
ang0 = 3.3
tsec = 0.01
;----state structure 
uv0={tsw:0,ang0:ang0,tsec:tsec,g0_id:g0_id,tm_id:tm_id, $
    d1_id:d1_id, b1_id:b1_id,b2_id:b2_id,bq_id:bq_id, $
    owin:owin,omodel:omodel,oview:oview}     
widget_control,g0_id,set_uvalue=uv0,/no_copy
;-----call xmanager
xmanager, 'rotearth', g0_id, cleanup='myclean', /no_block
end