;-------------------------------------------------
; SunEarthMoon
; Intro. IDL program. (2013): Chapt. 7.4   
; Author:  Tadashi Ito     
;-------------------------------------------------
;--- creates anaglyph     
function mk_anaglyph,imgl,imgr
aimg=imgr
aimg[0,*,*]=reform(imgl[0,*,*])
return, aimg
end 
;--- button 1 :rotation is ON
pro b1_ev,ev
widget_control, ev.top, get_uvalue=p0,/no_copy
widget_control,(*p0).tm_id, timer=(*p0).tm
(*p0).ro=1
widget_control, ev.top,set_uvalue=p0,/no_copy
end
;--- button 2 : rotation stop
pro b2_ev,ev
widget_control, ev.top, get_uvalue=p0,/no_copy
(*p0).ro=0
widget_control, ev.top,set_uvalue=p0,/no_copy  
end
;--- button 3 : anagrif on/off
pro b3_ev,ev
widget_control, ev.top, get_uvalue=p0,/no_copy
(*p0).an=((*p0).an eq 0)? 1:0
widget_control, ev.top,set_uvalue=p0,/no_copy  
end
;--- quit button
pro bq_ev,ev
widget_control, /destroy, ev.top
end
;-------------------------------------
pro sunearthmoon_event,ev
if tag_names(ev,/structure_name) ne 'WIDGET_TIMER' then goto, skip_all
;---recover status
widget_control, ev.top, get_uvalue=p0,/no_copy
;--geometry
zinf= -6    ;
eyeang=2.  ;parallax
;---clip image
(*p0).obufr->getproperty,image_data=imgr
;---check anagrif flag
if (*p0).an eq 0 then goto, skip_ana
;----parallax
(*p0).omodel->getproperty,transform=tmsav
(*p0).omodel->translate,0,0,-(*p0).zs-zinf
(*p0).omodel->rotate,[0,1,0],eyeang
(*p0).omodel->translate,0,0, (*p0).zs+zinf
;---draw to buffer
(*p0).obufl->draw,(*p0).oview
(*p0).obufl->getproperty,image_data=imgl
;---back
(*p0).omodel->setproperty,transform=tmsav
;---anaglyph
imga=mk_anaglyph(imgl,imgr)
;------draw image
skip_ana:
if (*p0).an eq 0 then (*p0).oanag->setproperty,data=imgr $
      else (*p0).oanag->setproperty,data=imga
(*p0).w1_id->draw, (*p0).oaview
;---revolution
ang=10.    ;rotation angle 
(*p0).omodel3t->rotate,[0,0,1],ang*0.5
;---the earth rotation
(*p0).omodel2->rotate,[0.281,-0.281,0.918],ang
;---the earth revolution
da=ang*0.2
arev=(*p0).erev
if arev+da ge 360. then arev -=360.
dx=-4.*(cos((arev+da)*!dtor)-cos(arev*!dtor))
dy=-4.*(sin((arev+da)*!dtor)-sin(arev*!dtor))
(*p0).omodel23t->translate,dx,dy,0.
(*p0).erev=arev+da
;---the sun rotation
(*p0).omodel1->rotate,[0,0,1],ang*0.1
;---draw to buffer
(*p0).obufr->draw, (*p0).oview          
;---timer
if (*p0).ro  eq 1 then widget_control,(*p0).tm_id,timer=(*p0).tm
;---restore
widget_control, ev.top,set_uvalue=p0,/no_copy
skip_all:
end
;-----------------------------------
pro sunearthmoon
;
g0_id=widget_base(title="sun_earth_moon_anagrif", /row)
g1_id=widget_base(g0_id, /frame, /column)
g2_id=widget_base(g0_id, /frame, /column)
;---for timer
tm_id=widget_base(g0_id,uvalue='tm',/column)
;---window size
ssiz=get_screen_size()
wsiz=long(ssiz[1]*0.8)
d1_id=widget_draw(g1_id,uname='d1', retain=2, xsize=wsiz,ysize=wsiz, $
graphics_level=2,color_model=0,renderer=1)
;---second group (button)
b1_id=widget_button(g2_id,value=filepath('shift_right.bmp', $
      subdir=['resource','bitmaps']), /bitmap,uname='b1',event_pro='b1_ev')
b2_id=widget_button(g2_id,value=filepath('pause.bmp',       $
      subdir=['resource','bitmaps']), /bitmap,uname='b2',event_pro='b2_ev')
b3_id=widget_button(g2_id,value=filepath('style.bmp',       $
      subdir=['resource','bitmaps']), /bitmap,uname='b3',event_pro='b3_ev')
bq=widget_button(g2_id,value=filepath('stop.bmp',           $
      subdir=['resource', 'bitmaps']),/bitmap,uname='bq',event_pro='bq_ev')
;----realize
widget_control, g0_id, /realize
;---window id  
widget_control, d1_id, get_value=w1_id 
;----create object 
;---1.sun image
oatom1=mkosun(scale=1.5,div=100,ostx=ostx)
omodel1=mkomodel()
omodel1->add,oatom1
;---2.earth image
oatom2=mkoearth(scale=0.6,div=100,oetx=oetx)
omodel2= mkomodel()
omodel2->add,oatom2
omodel2->rotate, [1,1,0], 23.4  ; natural tilt of the earth
;---3.moon image
oatom3=mkomoon(scale=0.3,div=60,omtx=omtx)
omodel3=mkomodel()
omodel3->add,oatom3
;---moon translation relative to center (earth)
omodel3t=mkomodel()
omodel3t->translate,0.8,0,0
omodel3t->add,omodel3
;--- earth & moon
omodel23= mkomodel()
omodel23->add,omodel3t
omodel23->add,omodel2
;---earth & moon translation relative to center (sun) 
omodel23t=mkomodel()
omodel23t->translate,-4,0,0
omodel23t->add,omodel23
;---sun & earth
omodel= mkomodel()
omodel->add,omodel23t
omodel->add,omodel1
;----rotate z-axis to upside
omodel->rotate,[1,0,0],-89
;---place the sun in the view volume
zs=-5
omodel->translate,0,0,zs
;---olight
lx=0. & ly=0. & lz=-2.5 & lint=4
olight=mkolight(intensity=lint,location=[lx,ly,lz])
omodellight=mkomodel()
omodellight->add,olight
;---view setting
vmax=5.8 & zmax=1 & zmin=-10 & eyez=6
oview=mkoview(viewplane_rect=[-vmax/2.,-vmax/2.,vmax,vmax],$
    color=[15,15,15],zclip=[zmax,zmin],eye=eyez,projection=2)
oview->add,omodel
oview->add,omodellight
;---buffer object 
obufr=obj_new('idlgrbuffer',dimensions=[wsiz,wsiz])
obufr->draw, oview
obufl=obj_new('idlgrbuffer',dimensions=[wsiz,wsiz])
obufl->draw, oview
;---image object for anagrif
oanag=obj_new('idlgrimage')
oamodel=mkomodel()
oamodel->add,oanag
oaview=mkoview(viewplane_rect=[0,0,wsiz,wsiz],color=[0,0,0], $
    zclip=[zmax,zmin],eye=eyez,projection=2)
oaview->add,oamodel
;---flag & param
ro=0       ;rotation flag
an=0       ;anagrif flag
erev=0.    ;initial earth revolution angle
tm=0.05    ;timer(sec)
;--- create state structure
p0=ptr_new({tm_id:tm_id, w1_id:w1_id, $
tm:tm, wsiz:wsiz, ro:ro, an:an, erev:erev, zs:zs, $
oview:oview, oaview:oaview, $
omodel1:omodel1,omodel2:omodel2, $
omodel:omodel,omodel23t:omodel23t,omodel3t:omodel3t, $
obufr:obufr, obufl:obufl, oanag:oanag, $
ostx:ostx,oetx:oetx,omtx:omtx }, /no_copy)
widget_control, g0_id, set_uvalue=p0,/no_copy
;-----call xmanager
xmanager, 'sunearthmoon', g0_id, cleanup='myclean', /no_block
end