;-------------------------------------------------
; fopt_1;  Fourier Optics_1
; Intro. IDL program. (2013): Chapt. 5.3.3   
; Author:  Tadashi Ito     
;-------------------------------------------------
;---rectangular apperture
function make_apt,n,d,wx,wy
n2=fix(n/2)
nx=fix(wx/d)
ny=fix(wy/d)
print,nx,ny
u=make_array(n,n)
ua=make_array(nx,ny,value=1.)
u[n2-fix(nx/2),n2-fix(ny/2)]=ua
return,u
end
;---main routine
pro fopt_1
n=512
lamda=0.002   ;micron
p=20.  ; screen pixel (micron)
z=500000. ;(micron)
d=lamda*z/p/n
print,' aperture size (micron)',d*n
;---apperture
u=make_apt(n,d,4.,2.)
device,decomposed=0
loadct,0
window,0,xsize=n,ysize=n
shade_surf,u
f=fft(u,/center)
af=abs(f)
window,1,xsize=n,ysize=n
shade_surf,af
window,2,xsize=n,ysize=n
loadct,2
tvscl,af
;---inverse
loadct,0
g=fft(af^2,/inverse)
ag=fftshift(abs(g))
window,3,xsize=n,ysize=n
shade_surf,ag
end
