;-------------------------------------------------
; fopt_3;  Fourier Holography
; Intro. IDL program. (2013): Chapt. 5.4   
; Author:  Tadashi Ito     
;-------------------------------------------------
function make_apt,n
;---8x8 dot F-pattern
xw=8
yw=8
img0=[ $
[0,0,0,0,0,0,0,0], $
[0,0,1,1,1,1,0,0], $
[0,0,1,0,0,0,0,0], $
[0,0,1,1,1,0,0,0], $
[0,0,1,0,0,0,0,0], $
[0,0,1,0,0,0,0,0], $
[0,0,1,0,0,0,0,0], $
[0,0,0,0,0,0,0,0]]
xw2=xw*4
yw2=yw*4
img0=rotate(img0,5)
img=congrid(img0,xw2,yw2)
n2=fix(n/2)
u=make_array(n,n)
u[n2-xw2,n2-yw2]=img
;---add reference wave
u[n2+xw*2,n2+yw*2]=100.
return,u
end
;---Main routine
pro fopt_3
n=512
lamda=0.002   ;micron
p=20.         ; screen pixel (micron)
z=500000.     ;(micron)
d=lamda*z/p/n
;---apperture
u=make_apt(n)
device,decomposed=0
loadct,0
window,0,xsize=n,ysize=n
shade_surf,u[(n/2-50):(n/2+50),(n/2-50):(n/2+50)]
f=fft(u,/center)
af=abs(f)^2
window,1,xsize=n,ysize=n
shade_surf,af
loadct,2
window,2,xsize=n,ysize=n
tvscl,af
;---inverse
loadct,0
g=fft(af,/inverse)
ag=g*conj(g)
ag=fftshift(ag)
;---mask the center peak
n2=n/2
w=4
zero=make_array(w,w)
ag[n2-fix(w/2),n2-fix(w/2)]=zero
ws=256
window,3,xsize=ws,ysize=ws
tvscl,ag[(n/2-ws/2):(n/2+ws/2),(n/2-ws/2):(n/2+ws/2)]
end
