;-------------------------------------------------
; mkocube ; creates cube object
; Intro. IDL program. (2013): Chapt. 7.2.3.2   
; Author:  Tadashi Ito     
;-------------------------------------------------
function mkocube, xsize=xsize,ysize=ysize,zsize=zsize,scale=scale
; creates a cube object
hx = (keyword_set(xsize))? xsize : 0.5
hy = (keyword_set(ysize))? ysize : 0.5
hz = (keyword_set(zsize))? zsize : 0.5
; vertex 
vtx=[[-hx,-hy,-hz],[hx,-hy,-hz],[hx,hy,-hz],[-hx,hy,-hz],$
     [-hx,-hy,hz],[hx,-hy,hz],[hx,hy,hz],[-hx,hy,hz]]
; polygon list for the vertex
poly = [[4,3,0,4,7],[4,0,1,5,4],[4,4,5,6,7],$
        [4,1,2,6,5],[4,2,3,7,6],[4,3,2,1,0]]
; scale the size if specified
if keyword_set(scale) then vtx=vtx*scale
; vertex color
c=255
vcol=[[c,0,0],[0,c,0],[0,0,c],[c,c,0],[0,c,c],[c,0,c]]        
return, obj_new('IDLgrPolygon',vtx,polygons=poly,style=2,vert_color=vcol)
end