;-------------------------------------------------
; mkoearth ; creates the earth object by surface
; Intro. IDL program. (2013): Chapt. 7.2.4   
; Author:  Tadashi Ito     
;-------------------------------------------------
function mkoearth, oetx=oetx,div=div,scale=scale
;---creates the Earth using IDLgrSurface
 dv = 360L
 r=0.5
 if keyword_set(div) then dv=long(div)
 if keyword_set(scale) then r=r*scale
 dv2 = dv*dv
 sph = make_array(3,dv2,/double)
 for i = 0L, dv-1 do begin
    for j = 0L, dv-1 do begin
        k = (i*dv)+j
        sph[0,k]=j* 360.0/(dv-1) ; longitude
        sph[1,k]=i*180.0/(dv-1)-90.0 ; latitude
        sph[2,k]=r               ; radius
        endfor
    endfor
;---convert the spherical coord to xyz coord
xyz = cv_coord(from_sphere=sph,/to_rect,/degrees)
x = reform(xyz[0, *],dv,dv)
y = reform(xyz[1, *],dv,dv)
z = reform(xyz[2, *],dv,dv)
;---Create a surface
osurf = obj_new('IDLgrSurface',z,x,y, color=[255,255,255], $
                     style=2, shading=1)
;---png texture file
arr=read_png(file_which('avhrr.png'),r,g,b)
sz=size(arr)
etx=bytarr(3,sz[1],sz[2])
etx[0,*,*]=r[arr]
etx[1,*,*]=g[arr]
etx[2,*,*]=b[arr]    
etx=congrid(etx,3,dv,dv) 
;---texture coord 
txc = fltarr(2,dv,dv)
for i=0, dv-1 do txc[0,*,i]=findgen(dv)/dv
for i=0, dv-1 do txc[1,i,*]=findgen(dv)/dv  
oetx=obj_new('IDLgrImage',etx)
osurf->setproperty,texture_map=oetx,texture_coord=txc
return, osurf
end