;-------------------------------------------------
; my_lmfit 
; Intro. IDL program. (2013): Chapt. 3.5   
; Author:  Tadashi Ito     
;-------------------------------------------------
;----------------------
function ffunc,x,p
return,p[0]*exp(-((x-p[1])/p[2])^2/2.>(-50))+p[3]+p[4]*x+p[5]*x^2     
end
;----------------------
function fderiv0,x,p
; x : scalar, numerical differentiation version
f=make_array(7,/double)
f[0]=ffunc(x,p)
dp=[1.,1.,0.1,1.,0.1,0.001]
dpm=diag_matrix(dp)
for i=0,5 do begin
p1=p+dpm[*,i]
p2=p-dpm[*,i]
f[i+1]=(ffunc(x,p1)-ffunc(x,p2))/(2.*dp[i])
endfor
return,f
end 
;----------------------
function fderiv1,x,p
; x : scalar, analytically differentiation version
f=make_array(7,/double)
f[0]=p[0]*exp(-((x-p[1])/p[2])^2/2.)+p[3]+p[4]*x+p[5]*x^2
f[1]=exp(-((x-p[1])/p[2])^2/2.)
f[2]=p[0]*exp(-((x-p[1])/p[2])^2/2.)*((x-p[1])/p[2]^2)
f[3]=p[0]*exp(-((x-p[1])/p[2])^2/2.)*((x-p[1])^2/p[2]^3)
f[4]=1.d0
f[5]=x
f[6]=x^2 
return,f
end
;----------------------
pro my_lmfit
;---generate data
x=dindgen(100)
a0=[208.4, 56.2, 3.54, 185.5, -2.234, 0.0091]
y=gfunc(x,a0,radd=3.)
plot,x,y,psym=10,color='000000'XL,background='FFFFFF'XL
;---initial guess
a=[100., 50., 5., 200., 0., 0]
fita = [1,1,1,1,1,1]
yfit=LMFIT(x,y,a, fita = fita, function_name = 'fderiv0',chisq=chi2,/double)
oplot,x,yfit,color='000000'XL
print,'chisq:',chi2
print,'generate:',a0
print,'fitted:',a
end
