;-------------------------------------------------
; my_trackball
; Intro. IDL program. (2013): Chapt. 7.5  
; Author:  Tadashi Ito     
;-------------------------------------------------
pro b1_ev, ev
widget_control, ev.top, get_uvalue=uv0, /no_copy
uv0.rotflg=0b
widget_control, ev.top, set_uvalue=uv0, /no_copy
end
;------------------
pro b2_ev, ev
widget_control, ev.top, get_uvalue=uv0, /no_copy
uv0.rotflg=1b
widget_control, ev.top, set_uvalue=uv0, /no_copy
end
;------------------
pro b3_ev, ev
widget_control, ev.top, get_uvalue=uv0, /no_copy
uv0.omodel->setproperty, transform=uv0.tm0
uv0.owin->draw, uv0.oview
widget_control, ev.top, set_uvalue=uv0, /no_copy
end
;------------------
pro b4_ev, ev
widget_control, /destroy, ev.top
end
;------------------
pro d1_ev, ev
widget_control, ev.top, get_uvalue=uv0, /no_copy
;--- type=4:expose
if (ev.type eq 4) then begin
    uv0.owin->draw, uv0.oview
    widget_control, ev.top, set_uvalue=uv0, /no_copy
    return
    endif
;--- handle trackball updates
if uv0.rotflg eq 0b then trans = uv0.otrack->update(ev,transform=qm) $
    else trans = uv0.otrack->update(ev,transform=qm,/translate)
if (trans ne 0) then begin
    uv0.omodel->getproperty, transform=tm
    uv0.omodel->setproperty, transform=tm#qm
    uv0.owin->draw, uv0.oview
    endif
;--- handle other events
;--- 0:button down
if (ev.type eq 0) then begin
    uv0.btndown = 1b
    widget_control, uv0.d1_id, draw_motion=1
    uv0.owin->draw, uv0.oview
    endif
;--- 1:button up
if (ev.type eq 1) then begin
    if (uv0.btndown eq 1b) then $
    uv0.owin->draw, uv0.oview
    uv0.btndown = 0b
    widget_control, uv0.d1_id, draw_motion=0
    endif
widget_control, ev.top, set_uvalue=uv0, /no_copy
end
;-----------------------------
pro my_trackball_event, ev
end
;------------------------------------------------
pro my_trackball
g0_id=widget_base(title='my_track_ball',/column)
g1_id=widget_base(g0_id,/row)
bmp_r=filepath('rotate.bmp',subdir=['resource','bitmaps'])
bmp_p=filepath('pan.bmp',subdir=['resource','bitmaps'])
bmp_0=filepath('view.bmp',subdir=['resource','bitmaps'])
bmp_s=filepath('stop.bmp',subdir=['resource','bitmaps'])
b1_id=widget_button(g1_id,value=bmp_r,/bitmap, uname='b1',event_pro='b1_ev')
b2_id=widget_button(g1_id,value=bmp_p,/bitmap, uname='b2',event_pro='b2_ev')
b3_id=widget_button(g1_id,value=bmp_0,/bitmap, uname='b3',event_pro='b3_ev')
b4_id=widget_button(g1_id,value=bmp_s,/bitmap, uname='b4',event_pro='b4_ev')
device,get_screen_size=ssize
ws=ssize[1]*0.5
d1_id=widget_draw(g0_id,uname='d1',xsize=ws,ysize=ws,retain=0,  $
   /expose_events,/button_events,graphics_level=2,event_pro='d1_ev') 
;--- realize widget	
widget_control, g0_id, /realize
;---window object
widget_control, d1_id, get_value=owin
;--- create a view (white)
oview = mkoview(color=[255,255,255])
;--- create a model
omodel = mkomodel()
oview->add, omodel
;--- create a surface atom object
z=mysinc2d(100,step=0.5,x=x,y=y)
oatom = obj_new('idlgrsurface', z,x,y,style=1,color=[0,100,255])
omodel->add, oatom
;--- scale
get_bounds, oatom, xr, yr, zr
sx=[0.,1./(xr[1]-xr[0])]
sy=[0.,1./(yr[1]-yr[0])]
sz=[0.,1./(zr[1]-zr[0])]
oatom->setproperty,xcoord_conv=sx,ycoord_conv=sy,zcoord_conv=sz
;--- initial direction
omodel->rotate, [1,0,0],-80
omodel->rotate, [0,1,0], 20
omodel->rotate, [1,0,0], 30
owin->draw,oview
omodel->getproperty, transform=tm0
;---  trackball object
otrack = obj_new('trackball',[ws*0.5, ws*0.5], ws*0.5)
;--- set uv0
uv0 = {rotflg:0b, btndown:0b, tm0:tm0, d1_id:d1_id, owin:owin, $
       oview:oview, omodel:omodel,otrack: otrack }
widget_control, g0_id, set_uvalue=uv0, /no_copy
xmanager, 'my_trackball', g0_id,cleanup='myclean', /no_block
end
